<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
<head>
  <meta charset="utf-8" />
  <meta name="generator" content="pandoc" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=yes" />
  <title>Cacti – Spine</title>
  <style type="text/css">
      code{white-space: pre-wrap;}
      span.smallcaps{font-variant: small-caps;}
      span.underline{text-decoration: underline;}
      div.column{display: inline-block; vertical-align: top; width: 50%;}
  </style>
  <link rel="stylesheet" href="Cacti-Github.css" />
</head>
<body>
<h1 id="spine">Spine</h1>
<p>Spine is the fast replacement for <code>cmd.php</code>. It is written in C to ensure ultimate performance for device polling and is multi-threaded. Expect a decrease in polling time of an order of magnitude. Polling times far less than 60 seconds for about 20,000 data sources are achievable e.g. on a dual XEON system supplied with 4 GB RAM and standard local disks.</p>
<p>When using Spine, don't change crontab or systemd settings! Always use poller.php with crontab or cactid.php for systemd!</p>
<p>To activate Spine instead of cmd.php, please visit <code>Console &gt; Configuration &gt; Settings &gt; Poller</code> and select spine and save as the <code>Poller Type</code>. If it's not showing as an available <code>Poller Type</code> this means either it has not been installed, or it's path has not been defined on the <code>Paths</code> tab within Settings.</p>
<p>Once saved, poller.php will use Spine on all subsequent polling cycles. Before making this change, ensure that Spine runs properly from the command line using the following test:</p>
<pre class="console"><code>cd /usr/local/spine/bin
./spine -R -V 3 -S
</code></pre>
<p>You should receive quite a bit of output depending on the size of your system. To increase the number of Threads and concurrent processes, you must modify the setting when editing your Data Collector under <code>Console &gt; Data Collection &gt; Data Collectors</code>.</p>
<p>While Spine is really fast, choosing the correct setup will ensure that all processor resources are used. Required settings for Maximum Concurrent Poller Processes are 1-2 times the number of CPU cores available for Spine.</p>
<p>When using spine, you must be senstivive to the numer of connections that are available for MySQL or MariaDB. Under <code>Console &gt; Utilities &gt; System Utilities &gt; General</code> Cacti will provide a recommended <code>max_connection</code> for MySQL/MariaDB.</p>
<h6 id="table-15-1-spine-parameters-maintained-at-the-system-level">Table 15-1. Spine Parameters maintained at the System Level</h6>
<table>
<thead>
<tr class="header">
<th>Name</th>
<th>Description</th>
</tr>
</thead>
<tbody>
<tr class="odd">
<td>Script and Script Server Timeout Value</td>
<td>The maximum time that Spine will wait on a script to complete, in units of seconds. If a Script Server Script is terminated due to timeout conditions, the value entered into the RRDfile will be NaN</td>
</tr>
</tbody>
</table>
<h6 id="table-15-2-spine-parameters-maintained-at-the-data-collector-level">Table 15-2. Spine Parameters maintained at the Data Collector Level</h6>
<table>
<thead>
<tr class="header">
<th>Name</th>
<th>Description</th>
</tr>
</thead>
<tbody>
<tr class="odd">
<td>Maximum Threads per Process</td>
<td>The maximum threads allowed per process. Using a higher number when using Spine will improve performance. Required settings are 10-15. Values above 50 are most often insane and may degrade performance vs. improve it.</td>
</tr>
<tr class="even">
<td>Number of PHP Script Servers</td>
<td>The number of concurrent script server processes to run per Spine process. Settings between 1 and 10 are accepted. Script Servers will pre-load a PHP environment. Then, the Script Server Scripts are included into that environment to save the overhead of reloading PHP and re-interpreting the binary for each call.</td>
</tr>
</tbody>
</table>
<h6 id="table-15-3-spine-parameters-maintained-at-the-device-level">Table 15-3. Spine Parameters maintained at the Device Level</h6>
<table>
<thead>
<tr class="header">
<th>Name</th>
<th>Description</th>
</tr>
</thead>
<tbody>
<tr class="odd">
<td>The Maximum SNMP OIDs Per SNMP Get Request</td>
<td>The maximum number of SNMP get OIDs to issue per SNMP request. Increasing this value increases poller performance over slow links. The maximum value is 60 OIDs, but that value is highly dependent on the MTU for your links to the remote devices. In some cases, using a <strong>Remote Data Collector</strong> is much more effective for polling remote <strong>Davices</strong>. Additionally, some <strong>Device Types</strong> do not handle large SNMP OID get requests. It's best to experiment until you find the correct setting.</td>
</tr>
<tr class="even">
<td>Device Threads</td>
<td>The maximum number spine threads used to gather information from a <strong>Device</strong>. When using this setting at the <strong>Device</strong> level, you have to ensure that you have enough threads allocated to a process so as to not block other <strong>Devices</strong> being polled from the same spine binary.</td>
</tr>
</tbody>
</table>
<h3 id="installing-spine">Installing Spine</h3>
<p>As Spine is written in C is must be compiled on the local system that it is to be installed on below is an example of compiling on centos and Ubuntu</p>
<h3 id="ubuntu">Ubuntu</h3>
<p>Install the required system packages</p>
<pre class="console"><code>apt-get install -y build-essential dos2unix dh-autoreconf libtool help2man libssl-dev libmysql++-dev librrds-perl libsnmp-dev
</code></pre>
<p>Next, download the version of spine you are looking for Typically this should match the version of Cacti you are using. In this case we will download Version 1.2.3 of Spine</p>
<pre class="console"><code>wget &lt;https://github.com/Cacti/spine/archive/release/1.2.3.zip&gt;
unzip 1.2.3
cd spine-release-1.2.3
</code></pre>
<p>Once you are in the spine directory its time to compile the poller by issuing the following commands:</p>
<pre class="console"><code>./bootstrap
./configure
make
make install
chown root:root /usr/local/spine/bin/spine
chmod u+s /usr/local/spine/bin/spine
</code></pre>
<p>Once that has completed, you will need to configure spine's config file</p>
<pre class="console"><code>vi /usr/local/spine/etc/spine.conf
</code></pre>
<p>Below is an example of a configuration however yours should match your cacti database username and password</p>
<pre class="console"><code>DB_Host       localhost
DB_Database   cacti
DB_User       spine
DB_Pass       spine
DB_Port       3306
#DB_UseSSL    0
#RDB_SSL_Key
#RDB_SSL_Cert
#RDB_SSL_CA
</code></pre>
<h3 id="centos">CentOS</h3>
<p>Install required system packages</p>
<pre class="console"><code>yum install -y gcc mysql-devel net-snmp-devel autoconf automake libtool dos2unix help2man
</code></pre>
<p>Then compile using the folowing commands</p>
<pre class="console"><code>./bootstrap
./configure
make
make install
chown root:root /usr/local/spine/bin/spine
chmod u+s /usr/local/spine/bin/spine
</code></pre>
<h3 id="testingdebugging-spine-via-command-line">Testing/Debugging spine via command line</h3>
<p>spine offer a a few differnt ways at the command line to test its functionality. Here are a few examples of some tests you can run by exectuing spine.</p>
<h4 id="test-spine-without-writing-results-to-database">Test Spine without writing results to database</h4>
<p>This test allows you to run spine and display the results to the console. This will not commit any of the data to the database by specifying the -R option.</p>
<pre class="shell"><code>/usr/local/spine/bin# ./spine -R -V 5
SPINE: Using spine config file [../etc/spine.conf]
2021-01-08 14:26:25 - SPINE: Poller[1] PID[13482] DEBUG: The path_php_server variable is /var/www/html/cacti/script_server.php
2021-01-08 14:26:25 - SPINE: Poller[1] PID[13482] DEBUG: The path_cactilog variable is /var/www/html/cacti/log/cacti.log
2021-01-08 14:26:25 - SPINE: Poller[1] PID[13482] DEBUG: The log_destination variable is 1 (FILE)
2021-01-08 14:26:25 - SPINE: Poller[1] PID[13482] DEBUG: The path_php variable is /usr/bin/php
2021-01-08 14:26:25 - SPINE: Poller[1] PID[13482] DEBUG: The availability_method variable is 2
2021-01-08 14:26:25 - SPINE: Poller[1] PID[13482] DEBUG: The ping_recovery_count variable is 3
2021-01-08 14:26:25 - SPINE: Poller[1] PID[13482] DEBUG: The ping_failure_count variable is 2
2021-01-08 14:26:25 - SPINE: Poller[1] PID[13482] DEBUG: The ping_method variable is 2
2021-01-08 14:26:25 - SPINE: Poller[1] PID[13482] DEBUG: The ping_retries variable is 1
2021-01-08 14:31:40 - SPINE: Poller[1] PID[13804] POLLER: Active Threads is 1, Pending is 1
2021-01-08 14:31:40 - SPINE: Poller[1] PID[13804] Device[38] DEBUG: Entering ICMP Ping
2021-01-08 14:31:40 - SPINE: Poller[1] PID[13804] Device[38] DEBUG: Attempting to ping 192.168.1.5, seq 9 (Retry 0 of 1)
2021-01-08 14:31:40 - SPINE: Poller[1] PID[13804] Device[38] DEBUG: Attempting to ping 192.168.1.5, seq 9 (Retry 0 of 1)
2021-01-08 14:31:40 - SPINE: Poller[1] PID[13804] Device[38] DEBUG: ICMP Device Alive, Try Count:1, Time:0.4990 ms
2021-01-08 14:31:40 - SPINE: Poller[1] PID[13804] Device[38] PING: Result ICMP: Device is Alive
2021-01-08 14:31:40 - SPINE: Poller[1] PID[13804] Device[38] HT[1] Device has no information for recache.
2021-01-08 14:31:40 - SPINE: Poller[1] PID[13804] Device[38] HT[1] NOTE: There are &#39;1&#39; Polling Items for this Device
2021-01-08 14:31:40 - SPINE: Poller[1] PID[13804] Device[38] DEBUG: The NIFTY POPEN returned the following File Descriptor 5
2021-01-08 14:31:40 - SPINE: Poller[1] PID[13804] Device[38] HT[1] DS[64] TT[9.95] SCRIPT: perl /var/www/html/cacti/scripts/ping.pl &#39;192.168.1.5&#39;, output: 0.047
2021-01-08 14:31:40 - SPINE: Poller[1] PID[13804] Device[38] HT[1] Total Time: 0.018 Seconds
2021-01-08 14:31:40 - SPINE: Poller[1] PID[13804] Device[38] HT[1] DEBUG: HOST COMPLETE: About to Exit Device Polling Thread Function
2021-01-08 14:31:40 - SPINE: Poller[1] PID[13804] DEBUG: The Value of Active Threads is 0 for Device ID 38
2021-01-08 14:31:40 - SPINE: Poller[1] PID[13804] POLLER: Active Threads is 0, Pending is 0
</code></pre>
<h4 id="running-spine-for-a-specifc-host">Running spine for a specifc host</h4>
<p>If you want to run spine for a specifc host you are able to do that with the following command:</p>
<pre class="shell"><code>/usr/local/spine/bin# ./spine -R -f 42 -l 42 -V 5
SPINE: Using spine config file [../etc/spine.conf]
2021-01-08 14:34:14 - SPINE: Poller[1] PID[14296] DEBUG: The path_php_server variable is /var/www/html/cacti/script_server.php
2021-01-08 14:34:14 - SPINE: Poller[1] PID[14296] DEBUG: The path_cactilog variable is /var/www/html/cacti/log/cacti.log
2021-01-08 14:34:14 - SPINE: Poller[1] PID[14296] DEBUG: The log_destination variable is 1 (FILE)
2021-01-08 14:34:14 - SPINE: Poller[1] PID[14296] DEBUG: The path_php variable is /usr/bin/php
2021-01-08 14:34:14 - SPINE: Poller[1] PID[14296] DEBUG: The Value of Active Threads is 1 for Device ID 0
2021-01-08 14:34:14 - SPINE: Poller[1] PID[14296] POLLER: Active Threads is 1, Pending is 0
2021-01-08 14:34:14 - SPINE: Poller[1] PID[14296] SPINE: Active Threads is 1, Pending is 1
2021-01-08 14:34:14 - SPINE: Poller[1] PID[14296] DEBUG: In Poller, About to Start Polling of Device for Device ID 42
2021-01-08 14:34:14 - SPINE: Poller[1] PID[14296] Device[42] IPv4 address 1.1.1.30 (1.1.1.30)
2021-01-08 14:34:14 - SPINE: Poller[1] PID[14296] Device[42] DEBUG: Entering ICMP Ping
2021-01-08 14:34:14 - SPINE: Poller[1] PID[14296] Device[42] DEBUG: Attempting to ping 1.1.1.30, seq 0 (Retry 0 of 1)
2021-01-08 14:34:14 - SPINE: Poller[1] PID[14296] Device[42] DEBUG: ICMP Device Alive, Try Count:1, Time:26.5849 ms
2021-01-08 14:34:14 - SPINE: Poller[1] PID[14296] Device[42] PING: Result ICMP: Device is Alive
2021-01-08 14:34:14 - SPINE: Poller[1] PID[14296] Device[42] HT[1] Device has no information for recache.
2021-01-08 14:34:14 - SPINE: Poller[1] PID[14296] Device[42] HT[1] NOTE: There are &#39;1&#39; Polling Items for this Device
2021-01-08 14:34:14 - SPINE: Poller[1] PID[14296] Device[42] DEBUG: The NIFTY POPEN returned the following File Descriptor 7
2021-01-08 14:34:14 - SPINE: Poller[1] PID[14296] Device[42] HT[1] DS[68] TT[42.86] SCRIPT: perl /var/www/html/cacti/scripts/ping.pl &#39;1.1.1.30&#39;, output: 26.9
2021-01-08 14:34:14 - SPINE: Poller[1] PID[14296] Device[42] HT[1] Total Time: 0.077 Seconds
2021-01-08 14:34:14 - SPINE: Poller[1] PID[14296] Device[42] HT[1] DEBUG: HOST COMPLETE: About to Exit Device Polling Thread Function
</code></pre>
<h4 id="spine-debug-via-gui">Spine debug via GUI</h4>
<p>You are also able to view spine debug information via the log file also spine allows you to raise the level of detail it provides in the log if you want to debug a specific device and see the spine output click enable device debug.</p>
<p>Below is an example output of Spine debug info via the log file</p>
<p><img src="images/spine-debug-gui.png" alt="spine" /></p>
<p>To enable more detailed spine logging go to <code>Console &gt; Configuration &gt; Settings &gt; Poller</code></p>
<p>You can choose from Detailed,Summary or No logging for Invalid data</p>
<p>Detailed Logging will be similar to cmd.php in that you will get a report for each data source that is having an issue</p>
<p>Summary provides a count of how many data sources are having an issue per device</p>
<p><img src="images/spine-parameters.png" alt="spine" /></p>
<h3 id="common-spine-related-errors">Common Spine related errors</h3>
<pre class="shell"><code>2021/01/08 14:38:44 - SPINE: Poller[1] PID[14838] FATAL: Unable to read configuration file! (Spine init)
</code></pre>
<p>Ensure that you have spine.conf in /usr/local/spine/etc on first install <code>spine.conf</code> may be <code>spine.conf.dist</code>.</p>
<pre class="shell"><code>DEBUG Falling back to UDP Ping Due to SetUID Issues
</code></pre>
<p>This is a permissions issue with spine ensure you have give spine the proper permissions</p>
<pre class="shell"><code>chmod u+s /usr/local/spine/bin/spine
</code></pre>
<hr />
<p><copy>Copyright (c) 2004-2021 The Cacti Group</copy></p>
</body>
</html>
